<?php

namespace Slack\Command;

use Slack\Message;

class Help extends Base
{
	private const LOGKEY = 'SH-';

	public function respond(): Message
	{
		$o = new Message;

		$o->text('Hi, I am a *NEW* Bot');

		// Version
		$o->addAttachment(
			Message\Attachment::item()
				->addField('Version',config('app.version','unknown'),TRUE)
		);

		return $o;
	}
}