<?php

namespace Slack\Options;

use Illuminate\Support\Facades\Log;
use Slack\Message;

/**
 * Class BlockSuggestion
(
    [type] => block_suggestion
    [user] => stdClass Object
        (
            [id] => U01QF1B0Y6B
            [username] => deon
            [name] => deon
            [team_id] => T01QF14NSQP
        )

    [container] => stdClass Object
        (
            [type] => view
            [view_id] => V034715K8GP
        )

    [api_app_id] => A4TCZ007N
    [token] => Oow8S2EFvrZoS9z8N4nwf9Jo
    [action_id] => system_include_brand
    [block_id] => YME
    [value] => abcdde
    [team] => stdClass Object
        (
            [id] => T01QF14NSQP
            [domain] => els953a-1
            [enterprise_id] => E01R1P48JCU
            [enterprise_name] => Leenooks Enteprise A
        )

    [enterprise] => stdClass Object
        (
            [id] => E01R1P48JCU
            [name] => Leenooks Enteprise A
        )

    [is_enterprise_install] =>
    [view] => stdClass Object
        (
            [id] => V034715K8GP
            [team_id] => T01QF14NSQP
            [type] => modal
            [blocks] => Array
            	(
            		[0] => stdClass Object
            			(
                        	[type] => section
                        	[block_id] => YME
                        	[text] => stdClass Object
                        		(
                        			[type] => mrkdwn
                        			[text] => Select Brands:
                        			[verbatim] =>
								)

							[accessory] => stdClass Object
								(
                        			[type] => multi_external_select
                        			[action_id] => system_include_brand
                        			[initial_options] => Array
                        				(
                        				)

									[placeholder] => stdClass Object
                        				(
                        					[type] => plain_text
                        					[text] => select...
                        					[emoji] => 1
										)

								)

						)

				)

			[private_metadata] =>
			[callback_id] =>
			[state] => stdClass Object
				(
					[values] => stdClass Object
						(
							[YME] => stdClass Object
								(
									[system_include_brand] => stdClass Object
										(
											[type] => multi_external_select
											[selected_options] => Array
												(
												)

										)

								)

						)

				)

			[hash] => 1645768594.IO10vEq1
			[title] => stdClass Object
				(
					[type] => plain_text
					[text] => Configure brands
					[emoji] => 1
				)

			[clear_on_close] =>
			[notify_on_close] =>
			[close] =>
			[submit] =>
			[previous_view_id] =>
			[root_view_id] => V034715K8GP
			[app_id] => A4TCZ007N
			[external_id] =>
			[app_installed_team_id] => T01QF14NSQP
			[bot_id] => B01RKPRAT0Q
		)
)
*/
abstract class BlockSuggestion extends Base
{
	protected const LOGKEY = 'OIM';

	public function __get($key)
	{
		switch ($key) {
			case 'action_id':
			case 'value':
				return object_get($this->_data,$key);

			case 'callback_id':
				return object_get($this->_data,'view.'.$key);

			default:
				return parent::__get($key);
		}
	}
}